/*
 128Gamma.C - Main 128Gamma Source File
*/
//					128Gamma - Data Encryption Project

#include <Windows.H>
#include <WindowsX.H>
#include <io.h>
#include <Stdio.H>
#include <Stdlib.H>
#include <ShellAPI.H>

#include "Headers/Definitions.H"
#include "Headers/Functions.H"

#include "Headers/PackFiles.H"
#include "Headers/UnpackFiles.H"

#include "Headers/128Coding.H"
#include "Headers/Cipher+.H"
#include "Headers/Cipher-.H"

#include "Dialogs/Password.H"
#include "Dialogs/About.H"
#include "Dialogs/Status.H"

////////////////////////////////////////////////////////////////////////

extern int WINAPI WinMain(HWND hInst, HWND hPrev, LPSTR Cmd, int nCmdShow)
{
	if(OpenMutex(0,0, TitleCaption))
	{
		MessageBox (NULL, "Only One Instance Of 128Gamma Can Run At A Time!" , TitleCaption, 0 + MB_ICONASTERISK + MB_SYSTEMMODAL);
		return 0;
	}
	CreateMutex(0,0, TitleCaption);

	hInstance = hInst;

	if(SetTempVariables())
		Error("Error Setting Temporary Files. Error 1.");

	if(strcmp(Cmd,"128GammaSignature") == 0)
	{
		char xSignature[30];
		sprintf(xSignature,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",65,117,116,104,101,110,116,105,99,32,49,50,56,71,97,109,109,97,32,83,105,103,110,97,116,117,114,101);
		MessageBox(0, xSignature ,GammaVersion, 0 + MB_TASKMODAL);
		return 0;
	}

	if(ProcessInput(Cmd)) // If No (Or Invalad) Input Diaplay About Box
	{
		DialogBox(hInstance,MAKEINTRESOURCE(1000),PasswordDialog_hWnd,AboutDialog);
	}
	return 0;
}

////////////////////////////////////////////////////////////////////////

